/**
 * This class contains functions specific to the Load throbber.
 * @param {GenericTab} generic An optional GenericThrobber to prevent having to create multiple copies.
 */
function LoadThrobber(generic) {
    // PRIVATE MEMBERS \\       var private = "test";
    var gen = generic ? generic : new GenericThrobber();
    var id = "loading";

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Shows this throbber.
     */
    this.show = function () {
        gen.show(id);
    };

    /**
     * Hides this throbber.
     */
    this.hide = function () {
        gen.hide(id);
    };
}
