/**
 * Confront section of the Farmer House scene.
 * @param {FarmerHouseController} controller The Farmer House controller.
 */
function FarmerHouseThreaten(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var toSuccess = new FarmerHouseScared(ctrl);
    var toFail = new FarmerHouseThreatenFail(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}


    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (ctrl.confront.get() !== FarmerHouseConfrontChoice.THREATEN) {
            return "";
        }
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        if (!ctrl.misc.weapon() || ctrl.misc.weapon().offence() < 4) {
            part += toFail.build();
        } else {
            part += toSuccess.build();
        }
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (ctrl.confront.get() !== FarmerHouseConfrontChoice.THREATEN) {
            return;
        }

        if (!ctrl.misc.weapon() || ctrl.misc.weapon().offence() < 4) {
            toFail.registerListeners();
        } else {
            toSuccess.registerListeners();
        }
    };
}
